{$X+}

unit ListSet;

interface

uses Pol ;

type

  PItem = ^TItem;
  TItem    = record
               Item:PPol;
               Next:PItem;
             end;

  PList = ^TList;
  TList    = object

                Num, Pos  : word;
                List, Akt : PItem;

                constructor Init;
                destructor  Done;virtual;
                procedure   Reset;virtual;

                procedure SetItem(n:word;i:PPol);
                procedure AddItem(n:word;i:PPol);virtual;
                procedure DelItem(n:word);virtual;
                procedure MoveItem(n:word;i:PPol);virtual;
                function  RemoveItem(n:word):PPol;virtual;
                function  GetNum:word;
                function  GetList:PItem;
                function  GetItem(n:word):PPol;
                function  GetNext(n:word):PItem;
                function  GetPoint(n:word):PItem;

                function  GetMemory:longint;virtual;
                function  GetNew:PList;virtual;
                procedure GetCopy(o:PList);virtual;
                function  GetNewCopy:PList;
              end;


  PListSet = ^TListSet;
  TListSet    = object(TList)

                   procedure AddSym(i:PPol);virtual;
                   procedure DelSym(i:PPol);virtual;
                   function  IsInside(i:PPol):boolean;virtual;
                   function  GetPosSym(n:word;i:PPol):word;virtual;
                   function  IsEmpty:boolean;virtual;
                   function  IsEqual(o:PListSet):boolean;virtual;
                   function  IsNotEqual(o:PListSet):boolean;virtual;
                   function  IsBigger(o:PListSet):boolean;virtual;
                   function  IsSmaller(o:PListSet):boolean;virtual;
                   function  IsBiggerOrEqual(o:PListSet):boolean;virtual;
                   function  IsSmallerOrEqual(o:PListSet):boolean;virtual;
                   procedure Sjednoceni(o:PListSet);virtual;
                   procedure Rozdil(o:PListSet);virtual;
                   procedure Prunik(o:PListSet);virtual;

                   function  GetNew:PList;virtual;

                 end;


  PSet = ^TSet;
  TSet    = object(TListSet)

                procedure AddSym(s:PPol);virtual;
                procedure DelSym(s:PPol);virtual;
                procedure MoveSym(s:PPol);virtual;

                function  GetNew:PList;virtual;

              end;


PPropLink = ^TPropLink;
TPropLink = record
              oldnet,
              newnet : PSym;
              next   : PPropLink;
            end;

PPropertyList = ^TPropertyList;
TPropertyList = object

                  List : PPropLink;

                  constructor Init;
                  destructor Done;virtual;

                  function  GetNewSym(p:PSym;m:PSet;st,ep:PSym):PSym;virtual;
                  function  GetOldNet(n:word):PSym;
                  function  GetNewNet(n:word):PSym;

                  function  GetMemory:longint;virtual;
                  function  GetNew:PPropertyList;virtual;
                  procedure GetCopy(h:PPropertyList);virtual;
                  function  GetNewCopy:PPropertyList;

                end;

implementation

uses Common;


function Pojed(var l:PItem;n:word):boolean;
begin
  if l=nil then begin Pojed:=false;exit;end;
  while (n>0) and (l^.Next<>nil) do begin
    l:=l^.Next;
    dec(n);
  end;
  if l^.Next=nil then Pojed:=false
                 else Pojed:=true;
end;



{##########################  Metody TList  ###############################}

constructor TList.Init;
begin
  if NotEnoughMemory then Fail;
  new(List);
  with List^ do begin
    Next:=nil;
    Item:=Sym('');
  end;
  Akt:=List;
  Num:=0;
  Pos:=1;
end;

destructor TList.Done;
var p,q:PItem;
begin
  p:=List;
  while p<>nil do begin
    q:=p;
    p:=p^.Next;
    with q^ do
      if (Item<>nil) and (TypeOf(Item^)<>TypeOf(TSym)) then
        dispose(Item,Done);
    dispose(q);
  end;
end;

procedure TList.Reset;
var p,q:PItem;
begin
  p:=List;
  while p^.next<>nil do begin
    q:=p;
    p:=p^.Next;
    with q^ do
      if (Item<>nil) and (TypeOf(Item^)<>TypeOf(TSym)) then
        dispose(Item,Done);
    dispose(q);
  end;
  List:=p;
  Akt:=p;
  Pos:=1;
  Num:=0;
end;

procedure TList.SetItem(n:word;i:PPol);
var p:PItem;
    m:word;
begin
  if (n<1) or (i=nil) then exit;
  m:=n;
  if n>=Pos then begin
    p:=Akt;n:=n-Pos+1;
  end else p:=List;
  if Pojed(p,n-1) then begin
    Pos:=m;Akt:=p;
    with p^ do begin
      if (Item<>nil) and (TypeOf(Item^)<>TypeOf(TSym)) then
        dispose(Item,Done);
      if TypeOf(i^)<>TypeOf(TSym) then Item:=i^.GetNewCopy
      else Item:=i;
    end;
  end;
end;

procedure TList.AddItem(n:word;i:PPol);
var p,q:PItem;
    b:boolean;
begin
  if (n<1) or (i=nil) or NotEnoughMemory then exit;
  p:=GetPoint(n);
  with p^ do begin
    new(q);
    q^.Next:=Next;
    q^.Item:=Item;
    Next:=q;
      if TypeOf(i^)<>TypeOf(TSym) then Item:=i^.GetNewCopy
      else Item:=i;
  end;
  inc(Num);
end;

procedure TList.DelItem(n:word);
var p,q:PItem;
    m:word;
begin
  if n>0 then begin
    m:=n;
    if n>=Pos then begin
      p:=Akt;n:=n-Pos+1;
    end else p:=List;
    if Pojed(p,n-1) then begin
      Pos:=m;Akt:=p;
      with p^ do begin
        q:=Next;
        if TypeOf(Item^)<>TypeOf(TSym) then dispose(Item,Done);
        Item:=Next^.Item;
        Next:=Next^.Next;
        dispose(q);
        dec(Num);
      end;
    end;
  end;
end;

procedure TList.MoveItem(n:word;i:PPol);
var p,q:PItem;
    b:boolean;
begin
  if (n<1) or (i=nil) or NotEnoughMemory then exit;
  p:=GetPoint(n);
  with p^ do begin
    new(q);
    q^.Next:=Next;
    q^.Item:=Item;
    Next:=q;
    Item:=i;
  end;
  inc(Num);
end;

function  TList.RemoveItem(n:word):PPol;
var p,q:PItem;
    m:word;
begin
  if n>0 then begin
    m:=n;
    if n>=Pos then begin
      p:=Akt;n:=n-Pos+1;
    end else p:=List;
    if Pojed(p,n-1) then begin
      Pos:=m;Akt:=p;
      with p^ do begin
        q:=Next;
        RemoveItem:=Item;
        Item:=Next^.Item;
        Next:=Next^.Next;
        dispose(q);
        dec(Num);
        exit;
      end;
    end;
  end;
  RemoveItem:=nil;
end;

function  TList.GetNum:word;
begin
  GetNum:=Num;
end;

function  TList.GetList:PItem;
begin
  GetList:=List;
end;

function  TList.GetItem(n:word):PPol;
var p:PItem;
    m:word;
begin
  m:=n;
  if n>=Pos then begin
    p:=Akt;n:=n-Pos+1;
  end else p:=List;
  if (n>0) and Pojed(p,n-1) then begin
    Pos:=m;Akt:=p;
    GetItem:=p^.Item;
  end else GetItem:=nil;
end;
 
function  TList.GetNext(n:word):PItem;
var p:PItem;
    m:word;
begin
  if n=0 then GetNext:=List else begin
    m:=n;
    if n>=Pos then begin
      p:=Akt;n:=n-Pos+1;
    end else p:=List;
    if Pojed(p,n-1) then begin
      Pos:=m;Akt:=p;
      GetNext:=p^.Next;
    end else GetNext:=nil;
  end;
end;

function  TList.GetPoint(n:word):PItem;
var p:PItem;
    m:word;
begin
  if n<>0 then begin
    m:=n;
    if n>=Pos then begin
      p:=Akt;n:=n-Pos+1;
    end else p:=List;
    Pojed(p,n-1);
    Pos:=m;Akt:=p;
    GetPoint:=p;
  end else GetPoint:=nil;
end;

function  TList.GetMemory:longint;
var i:longint;
    p:PItem;
begin
  i:=SizeOf(TList);
  p:=List;
  while p<>nil do begin
    inc(i,SizeOf(p^));
    if TypeOf(p^.Item^)<>TypeOf(TSym) then
      inc(i,p^.Item^.GetMemory);
    p:=p^.Next;
  end;
  GetMemory:=i;
end;

function  TList.GetNew:PList;
begin
  GetNew:=new(PList,Init);
end;

procedure TList.GetCopy(o:PList);
var n:word;
    p:PItem;
begin
  if o<>nil then begin
    with o^ do
      while List^.Next<>nil do DelItem(1);
    n:=1;
    p:=List;
    while (n<=Num) and MemOk do begin
      o^.AddItem(n,p^.Item);
      p:=p^.next;
      inc(n);
    end;
    with o^ do begin
      Pos:=1;Akt:=List;
    end;
  end;
end;

function  TList.GetNewCopy:PList;
var p:PList;
begin
  p:=GetNew;
  GetCopy(p);
  if not MemOk and (p<>nil) then begin
    dispose(p,Done);
    p:=nil;
  end;
  GetNewCopy:=p;
end;



{########################## Metody ListSet #############################}

procedure TListSet.AddSym(i:PPol);
begin end;

procedure TListSet.DelSym(i:PPol);
begin end;

function  TListSet.IsInside(i:PPol):boolean;
var n:word;
    b:boolean;
    p:PItem;
begin
  n:=1;
  b:=false;
  p:=List;
  if i<>nil then
    while not(b) and (n<=Num) do
      if i^.Equal(p^.Item) then b:=true
      else begin
        p:=p^.next;
        inc(n);
      end;
  IsInside:=b;
end;

function  TListSet.GetPosSym(n:word;i:PPol):word;
var b:boolean;
    p:PItem;
begin
  b:=false;
  p:=List;
  if i<>nil then
    while not(b) and (n<=Num) do
      if i^.Equal(p^.Item) then b:=true
      else begin
        p:=p^.next;
        inc(n);
      end;
  if b then GetPosSym:=n
       else GetPosSym:=0;
end;

function  TListSet.IsEmpty:boolean;
begin
  IsEmpty:=Num=0;
end;

function  TListSet.IsEqual(o:PListSet):boolean;
begin
  IsEqual:=IsSmallerOrEqual(o) and IsBiggerOrEqual(o);
end;

function  TListSet.IsNotEqual(o:PListSet):boolean;
begin
  IsNotEqual:=not(IsEqual(o));
end;

function  TListSet.IsBigger(o:PListSet):boolean;
begin
  IsBigger:=IsBiggerOrEqual(o) and not(IsSmallerOrEqual(o));
end;

function  TListSet.IsSmaller(o:PListSet):boolean;
begin
  IsSmaller:=IsSmallerOrEqual(o) and not(IsBiggerOrEqual(o));
end;

function  TListSet.IsBiggerOrEqual(o:PListSet):boolean;
var n:word;
    b:boolean;
    p:PItem;
begin
  b:=true;
  n:=1;
  if o<>nil then begin
    p:=o^.List;
    while b and (n<=o^.Num) do
      if IsInside(p^.Item) then begin
        p:=p^.next;
        inc(n);
      end else b:=false;
  end;
  IsBiggerOrEqual:=b;
end;

function  TListSet.IsSmallerOrEqual(o:PListSet):boolean;
var n:word;
    b:boolean;
    p:PItem;
begin
  b:=true;
  n:=1;
  if o<>nil then
    p:=List;
    while b and (n<=Num) do
      if o^.IsInside(p^.Item) then begin
        p:=p^.next;
        inc(n);
      end else b:=false;
  IsSmallerOrEqual:=b;
end;

procedure TListSet.Sjednoceni(o:PListSet);
var n:word;
    p:PItem;
begin
  if o<>nil then begin
    n:=1;
    p:=List;
    while (n<=Num) and MemOk do begin
      o^.AddSym(p^.Item);
      p:=p^.next;
      inc(n);
    end;
  end;
end;

procedure TListSet.Rozdil(o:PListSet);
var n:word;
    p:PItem;
begin
  if o<>nil then begin
    p:=List;
    for n:=1 to Num do begin
      o^.DelSym(p^.Item);
      p:=p^.next;
    end;
  end;
end;

procedure TListSet.Prunik(o:PListSet);
var n:word;
    i:PPol;
    p:PItem;
begin
  if o<>nil then begin
    n:=1;
    p:=o^.List;
    while n<=o^.Num do begin
      i:=p^.Item;
      if IsInside(i) then begin
        p:=p^.next;
        inc(n);
      end else o^.DelItem(n);
    end;
  end;
end;

function  TListSet.GetNew:PList;
begin
  GetNew:=new(PListSet,Init);
end;



{############################## Metody TSet ###########################}

procedure TSet.AddSym(s:PPol);
var n:word;
    p:PItem;
begin
  if (s<>nil) and not(IsInside(s)) then begin
    n:=1;
    p:=List;
    while (n<=Num) and not (s^.Mensi(p^.Item)) do begin
      p:=p^.next;
      inc(n);
    end;
    AddItem(n,s);
  end;
end;

procedure TSet.DelSym(s:PPol);
var n:word;
    p:PItem;
begin
  if s=nil then exit;
  n:=1;
  p:=List;
  while n<=Num do
    if s^.Equal(p^.Item) then DelItem(n)
    else begin
      p:=p^.next;
      inc(n);
    end;
end;

procedure TSet.MoveSym(s:PPol);
var n:word;
    p:PItem;
begin
  if s<>nil then
    if IsInside(s) then dispose(s,Done)
    else begin
      n:=1;
      p:=List;
      while (n<=Num) and not (s^.Mensi(p^.Item)) do begin
        p:=p^.next;
        inc(n);
      end;
      MoveItem(n,s);
    end;
end;

function  TSet.GetNew:PList;
begin
  GetNew:=new(PSet,Init);
end;



{########################  Metody TPropertyList  ###########################}

constructor TPropertyList.Init;
begin
  if NotEnoughMemory then Fail;
  List:=nil;
end;

destructor TPropertyList.Done;
var p:PPropLink;
begin
  while List<>nil do begin
    p:=List;
    List:=p^.next;
    dispose(p);
  end;
end;

function  TPropertyList.GetNewSym(p:PSym;m:PSet;st,ep:PSym):PSym;
var q:PPropLink;
    s:PSym;
begin
  if p=nil then begin
    GetNewSym:=nil;exit;
  end;
  q:=List;
  if p=Sym(start) then p:=st
  else if p=Sym(epsilon) then p:=ep;
  while q<>nil do begin
    if q^.oldnet=p then begin
      GetNewSym:=q^.newnet;
      exit;
    end;
    q:=q^.next;
  end;
  s:=Sym('<'+p^.GetStr+'>');
  if m<>nil then
    while m^.IsInside(s) or (s=st) or (s=ep) do
      s:=Sym('<'+s^.GetStr+'>');
  new(q);
  with q^ do begin
    next:=List;
    oldnet:=p;
    newnet:=s;
  end;
  List:=q;
  GetNewSym:=s;
end;

function  TPropertyList.GetOldNet(n:word):PSym;
var q:PPropLink;
begin
  q:=List;
  while (q<>nil) and (n>1) do begin
    q:=q^.next;
    dec(n);
  end;
  if (n=0) or (q=nil) then GetOldNet:=nil
  else GetOldNet:=q^.oldnet;
end;

function  TPropertyList.GetNewNet(n:word):PSym;
var q:PPropLink;
begin
  q:=List;
  while (q<>nil) and (n>1) do begin
    q:=q^.next;
    dec(n);
  end;
  if (n=0) or (q=nil) then GetNewNet:=nil
  else GetNewNet:=q^.newnet;
end;

function  TPropertyList.GetMemory:longint;
var i:longint;
    q:PPropLink;
begin
  i:=SizeOf(TPropertyList);
  q:=List;
  while q<>nil do begin
    inc(i,SizeOf(q));
    q:=q^.next;
  end;
  GetMemory:=i;
end;

function  TPropertyList.GetNew:PPropertyList;
begin
  GetNew:=new(PPropertyList,Init);
end;

procedure TPropertyList.GetCopy(h:PPropertyList);
var p,q:PPropLink;
begin
  if h=nil then exit;
  with h^ do
    while List<>nil do begin
      p:=List;
      List:=p^.next;
      dispose(p);
    end;
  q:=List;
  while q<>nil do begin
    new(p);
    with p^ do begin
      next:=h^.List;
      oldnet:=q^.oldnet;
      newnet:=q^.newnet;
    end;
    h^.List:=p;
    q:=q^.next;
  end;
end;

function  TPropertyList.GetNewCopy:PPropertyList;
var p:PPropertyList;
begin
  p:=GetNew;
  GetCopy(p);
  GetNewCopy:=p;
end;

end.



