{$X+}
unit MyApp;

interface

uses Crt, Objects, Drivers, Views, Dialogs, Editor, Common, Pol, Grammar,
     BigGram, GadGets, DGHelp;


function ExecDialog(P:PDialog;Data:Pointer):Word;
function CreateFindDialog:PDialog;
function CreateReplaceDialog:PDialog;
function DoEditDialog(Dialog:Integer;Info:Pointer):Word;
function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
function MyLowMem:boolean;
function GetWinNum:byte;
procedure Wait(ms:word);
procedure ErrorBox(s:string;hlp:word);


const WinNums : set of 0..9 = [];

const
  cmBusy   = 106;
  cmUpDate = 107;
  cmEditor = 108;

const
  cmDJednoduche   = 150;
  cmDChomskeho    = 151;
  cmDRekurze      = 152;
  cmDGreibachova  = 153;
  cmTNadbytecne   = 154;
  cmTNedostupne   = 155;
  cmTRedukovana   = 156;
  cmTBezEpsilon   = 157;
  cmTCykly        = 158;
  cmTVlastni      = 159;
  cmTJednoduche   = 160;
  cmTBezRekurze   = 161;
  cmTChomskeho    = 162;
  cmTGreibachova  = 163;
  cmTZjednoduseni = 164;
  cmReadGrammar   = 165;
  cmWriteGrammar  = 166;
  cmUkazStav      = 167;
  cmDoWrite       = 168;

type

  PViewCompile = ^TViewCompile;
  TViewCompile = object(TView)
             r:word;
             s:string;
             Cancel:boolean;

             constructor Init(var Bounds: TRect);
             procedure Draw;virtual;
             procedure HandleEvent(var Event: TEvent);virtual;
           end;

  PCompileDialog = ^TCompileDialog;
  TCompileDialog = object(TDialog)
                     constructor Init(s:string);
                   end;

  PViewStates = ^TViewStates;
  TViewStates = object(TView)
                  gr:PBigGrammar;

                  constructor Init(var Bounds: TRect;g:PBigGrammar);
                  procedure Draw; virtual;
                end;

  PStateDialog = ^TStateDialog;
  TStateDialog = object(TDialog)
                   constructor Init(g:PBigGrammar);
                 end;

  PMyClock = ^TMyClock;
  TMyClock = object(TClockView)
    constructor Init(var Bounds: TRect);
    procedure HandleEvent(var Event: TEvent);virtual;
    procedure Draw;virtual;
  end;

  PMyEditWindow = ^TMyEditWindow;
  TMyEditWindow = object(TEditWindow)
    Gramatika: PBigGrammar;
    constructor Init(var Bounds: TRect;
      FileName: FNameStr; ANumber: Integer);
    destructor Done;virtual;
    procedure ReadGrammar;virtual;
    procedure HandleEvent(var Event: TEvent);virtual;
  end;


implementation

uses StdDlg, MsgBox, App;

const LowGrammar = 0;
      LowHashTab = 0;

constructor TViewCompile.Init(var Bounds:TRect);
begin
  TView.Init(Bounds);
  Cancel:=false;
  CtrlBreakHit:=false;
  EventMask:=EventMask or evMyMessage;
end;

procedure TViewCompile.Draw;
var
  B: TDrawBuffer;
  Color: Word;
  St,p: String[80];
begin
  Color := GetColor($01);
  MoveChar(B, ' ', Color, Size.X);
  WriteLine(0, 0, Size.X, 1, B);
  WriteLine(0, 1, Size.X, 1, B);
  MoveStr(B[3],'Soubor : '+s, Color);
  WriteLine(0, 2, Size.X, 1, B);

  MoveChar(B, ' ', Color, Size.X);
  WriteLine(0, 3, Size.X, 1, B);
  str(r:4,p);
  st:='dek : '+p+'            Pam : ';
  str(round((memavail-LowFree)/100)/10:5:1,p);
  st:=st+p+'K';
  MoveStr(B[3], St, Color);
  WriteLine(0, 4, Size.X, 1, B);

  MoveChar(B, ' ', Color, Size.X);
  WriteLine(0, 5, Size.X, Size.Y-6, B);

  Color:=blue*16+yellow;
  MoveChar(B, ' ', Color, Size.X);
  if Cancel then begin
    MoveStr(B[9], 'Perueno:', Color);
    Color:=Color+blink;
    MoveStr(B[20], 'Stisknte klvesu', Color);
  end else
    MoveStr(B[10], 'Ctrl-Break peru peklad', Color);
  WriteLine(0, Size.Y-1, Size.X, 1, B);
end;

procedure TViewCompile.HandleEvent(var Event: TEvent);
type wordptr=^word;
var pomr:wordptr;
begin
  TView.HandleEvent(Event);
  if (Event.What=evMyMessage) and (Event.Command=msLine) then begin
    pomr:=wordptr(Event.InfoPtr);
    r:=pomr^;
    Draw;
    ClearEvent(Event);
  end;
  if CtrlBreakHit and not Cancel then begin
    if EventAvail then GetEvent(Event);
    Cancel:=true;
    DrawView;
    CtrlBreakHit:=false;
    pomr^:=0;
    repeat
      Application^.Idle;
    until EventAvail;
    GetEvent(Event);
    ClearEvent(Event);
  end;
end;

constructor TCompileDialog.Init(s:string);
var R: TRect;
    p: PViewCompile;
begin
  R.Assign(0, 0, 48, 10);
  R.Move((Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
  TDialog.Init(R, 'Peklad');
  R.Assign(1,1,47,9);
  p:=New(PViewCompile, Init(R));
  p^.s:=s;
  Insert(p);
  Flags:=0;
  EventMask:=EventMask or evMyMessage;
  Options:=ofBuffered or ofTopSelect;
  SetState(sfSelected,true);
  SetState(sfModal,true);
end;

{#########################################################################}

function ExecDialog(P:PDialog;Data:Pointer):Word;
var Result:Word;
begin
  Result:=cmCancel;
  P:=PDialog(Application^.ValidView(P));
  if P<>nil then begin
    if Data<>nil then P^.SetData(Data^);
    Result:=DeskTop^.ExecView(P);
    if (Result<>cmCancel) and (Data<>nil) then P^.GetData(Data^);
    Dispose(P, Done);
  end;
  ExecDialog:=Result;
end;

function CreateFindDialog:PDialog;
var D:PDialog;
    Control:PView;
    R:TRect;
begin
  R.Assign(0,0,38,12);
  D:=New(PDialog,Init(R,'Hledn'));
  with D^ do begin
    Options:=Options or ofCentered;
    HelpCtx:=hcHledani;

    R.Assign(3,3,32,4);
    Control:=New(PInputLine,Init(R,80));
    Insert(Control);
    R.Assign(2,2,15,3);
    Insert(New(PLabel,Init(R,'~T~ext pro hledn',Control)));
    R.Assign(32,3,35,4);
    Insert(New(PHistory,Init(R,PInputLine(Control),10)));

    R.Assign(3,5,35,7);
    Insert(New(PCheckBoxes,Init(R,
      NewSItem('~P~smo rozliovat',
      NewSItem('~J~en cel slova',nil)))));

    R.Assign(14,9,24,11);
    Insert(New(PButton,Init(R,'O~K~',cmOk,bfDefault)));
    Inc(R.A.X,12);Inc(R.B.X,12);
    Insert(New(PButton,Init(R,'~Z~ruit',cmCancel,bfNormal)));

    SelectNext(False);
  end;
  CreateFindDialog:=D;
end;

function CreateReplaceDialog:PDialog;
var D:PDialog;
    Control:PView;
    R:TRect;
begin
  R.Assign(0,0,40,16);
  D:=New(PDialog,Init(R,'Nahrazen'));
  with D^ do begin
    Options:=Options or ofCentered;
    HelpCtx:=hcNahrazeni;

    R.Assign(3,3,34,4);
    Control:=New(PInputLine,Init(R,80));
    Insert(Control);
    R.Assign(2,2,15,3);
    Insert(New(PLabel,Init(R,'~T~ext pro hledn',Control)));
    R.Assign(34,3,37,4);
    Insert(New(PHistory,Init(R,PInputLine(Control),10)));

    R.Assign(3,6,34,7);
    Control:=New(PInputLine,Init(R,80));
    Insert(Control);
    R.Assign(2,5,12,6);
    Insert(New(PLabel,Init(R,'No~v~ text',Control)));
    R.Assign(34,6,37,7);
    Insert(New(PHistory,Init(R,PInputLine(Control),11)));

    R.Assign(3,8,37,12);
    Insert(New(PCheckBoxes,Init(R,
      NewSItem('~P~smo rozliovat',
      NewSItem('~J~en cel slova',
      NewSItem('~K~urzor ukazuje',
      NewSItem('~N~hrada vech',nil)))))));

    R.Assign(17,13,27,15);
    Insert(New(PButton,Init(R,'O~K~',cmOk,bfDefault)));
    R.Assign(28,13,38,15);
    Insert(New(PButton,Init(R,'~Z~ruit',cmCancel,bfNormal)));

    SelectNext(False);
  end;
  CreateReplaceDialog:=D;
end;

function DoEditDialog(Dialog:Integer;Info:Pointer):Word;
var R:TRect;
    T:TPoint;
begin
  case Dialog of
    edOutOfMemory:
      DoEditDialog:=MessageBox('Nedostatek pamti pro vykonn tto operace.',
        nil,mfError+mfOkButton);
    edReadError:
      DoEditDialog:=MessageBox('Chyba bhem ten souboru %s.',
        @Info,mfError+mfOkButton);
    edWriteError:
      DoEditDialog:=MessageBox('Chyba bhem zpisu do souboru %s.',
        @Info,mfError+mfOkButton);
    edCreateError:
      DoEditDialog:=MessageBox('Chyba bhem vzniku souboru %s.',
        @Info,mfError+mfOkButton);
    edSaveModify:
      DoEditDialog:=MessageBox('%s byl upraven. Uloit?',
        @Info,mfInformation+mfYesNoCancel);
    edSaveUntitled:
      DoEditDialog:=MessageBox('Uloit soubor bez jmna?',
        nil,mfInformation+mfYesNoCancel);
    edSaveAs:
      DoEditDialog:=ExecDialog(New(PFileDialog,Init('*.grm',
        'Uloit soubor jako','~J~mno',fdOkButton,101)),Info);
    edFind:
      DoEditDialog:=ExecDialog(CreateFindDialog,Info);
    edSearchFailed:
      DoEditDialog:=MessageBox('Hledan etzec nebyl nalezen.',
        nil,mfError+mfOkButton);
    edReplace:
      DoEditDialog:=ExecDialog(CreateReplaceDialog,Info);
    edReplacePrompt:
      begin
        R.Assign(0,1,40,8);
        R.Move((Desktop^.Size.X - R.B.X) div 2,0);
        Desktop^.MakeGlobal(R.B,T);
        Inc(T.Y);
        if TPoint(Info).Y<=T.Y then
          R.Move(0,Desktop^.Size.Y - R.B.Y - 2);
        DoEditDialog:=MessageBoxRect(R,'Nahradit tento ppad?',
          nil,mfYesNoCancel+mfInformation);
      end;
  end;
end;

function OpenEditor(FileName: FNameStr; Visible: Boolean): PEditWindow;
var
  P: PView;
  R: TRect;
begin
  P:=Message(DeskTop,evBroadcast,cmGetTitle,@FileName);
  if P=nil then begin
    DeskTop^.GetExtent(R);
    P := Application^.ValidView(New(PMyEditWindow,
      Init(R, FileName, GetWinNum)));
    if not Visible then P^.Hide;
    DeskTop^.Insert(P);
  end else P^.Select;
  OpenEditor := PEditWindow(P);
end;

function MyLowMem:boolean;
begin
  if MemOk then
    if MaxAvail<=LowFree then begin
      Message(DeskTop,evMyMessage,msEnd,nil);
      MemOk:=false;
      Application^.OutOfMemory;
      MyLowMem:=true;
    end else MyLowMem:=false
  else MyLowMem:=true;
end;

function GetWinNum:byte;
var i:byte;
begin
  i:=0;
  while (i<10) and (i in WinNums) do inc(i);
  if i<10 then GetWinNum:=i else GetWinNum:=wnNoNumber;
end;

procedure Wait(ms:word);
var i:word;
begin
  for i:=0 to ms div 50 do begin
    Message(Application,evBroadcast,cmUpDate,nil);
    Delay(50);
  end;
end;


{######################### Metody TViewStates ###########################}

constructor TViewStates.Init(var Bounds: TRect;g:PBigGrammar);
begin
  TView.Init(Bounds);
  gr:=g;
  HelpCtx:=hcSoubor;
end;

procedure TViewStates.Draw;
const ano= 'ano';
      ne = 'ne';
var
  B: TDrawBuffer;
  Color: Word;
  s: String[60];
  stat: TSetOfStates;
begin
  stat:=gr^.SetOfStates;
  Color := GetColor($01);
  MoveChar(B, ' ', Color, Size.X);
  WriteLine(0, 0, Size.X, 1, B);
  s:='Gramatika je bez nadbytench symbol      :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _nemaNadbytecne_ in stat then s:=s+ano
                              else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 1, Size.X, 1, B);
  s:='Gramatika je bez nedostupnch symbol      :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _nemaNedostupne_ in stat then s:=s+ano
                              else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 2, Size.X, 1, B);
  s:='Gramatika je redukovan                    :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeRedukovana_ in stat then s:=s+ano
                            else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 3, Size.X, 1, B);
  s:='Gramatika je bez epsilonovch pravidel     :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeBezEpsilon_ in stat then s:=s+ano
                            else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 4, Size.X, 1, B);
  s:='Gramatika je bez cykl                     :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _nemaCyklus_ in stat then s:=s+ano
                          else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 5, Size.X, 1, B);
  s:='Gramatika je vlastn                       :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeVlastni_ in stat then s:=s+ano
                         else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 6, Size.X, 1, B);
  s:='Gramatika je bez jednoduchch pravidel     :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeJednoducha_ in stat then s:=s+ano
                            else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 7, Size.X, 1, B);
  s:='Gramatika je bez lev rekurze              :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeBezRekurze_ in stat then s:=s+ano
                            else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 8, Size.X, 1, B);
  s:='Gramatika je v Chomskho normln form    :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeChomskeho_ in stat then s:=s+ano
                           else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 9, Size.X, 1, B);
  s:='Gramatika je v Greibachov normln form  :  ';
  MoveChar(B, ' ', Color, Size.X);
  if _jeGreibachova_ in stat then s:=s+ano
                             else s:=s+ne;
  MoveStr(B[1], s, Color);
  WriteLine(0, 10, Size.X, 1, B);

  MoveChar(B, ' ', Color, Size.X);
  WriteLine(0, 11, Size.X, 1, B);
  MoveChar(B, ' ', Color, Size.X);
  str(gr^.GetMemory-LowGrammar:6,s);
  MoveStr(B[1], '   Pam obsazen gramatikou        : '+s+' B', Color);
  WriteLine(0, 12, Size.X, 1, B);
  MoveChar(B, ' ', Color, Size.X);
  str(HashTab.GetMemory-LowHashTab:6,s);
  MoveStr(B[1], '   Pam obsazen tabulkou symbol  : '+s+' B', Color);
  WriteLine(0, 13, Size.X, 1, B);
  MoveChar(B, ' ', Color, Size.X);
  str(MemAvail:6,s);
  MoveStr(B[1], '   Velikost voln pamti            : '+s+' B', Color);
  WriteLine(0, 14, Size.X, 1, B);

  { Fill in rest of rectangle }
  MoveChar(B, ' ', Color, Size.X);
  WriteLine(0, 15, Size.X, Size.Y-15, B);
end;

constructor TStateDialog.Init(g:PBigGrammar);
var R: TRect;
begin
  R.Assign(10,1,69,21);
  TDialog.Init(R, 'Stav gramatiky');
  HelpCtx:=hcStavGramatiky;
  R.Assign(4,1,57,18);
  Insert(New(PViewStates, Init(R,g)));
  R.Assign(24,17,34,19);
  Insert(New(PButton, Init(R, 'OK', cmCancel, bfNormal)));
end;

constructor TMyClock.Init(var Bounds: TRect);
begin
  TClockView.Init(Bounds);
  EventMask:=EventMask or evBroadcast;
end;

procedure TMyClock.HandleEvent(var Event: TEvent);
begin
  TClockView.HandleEvent(Event);
  if Event.What=evBroadcast then begin
    case Event.Command of
      cmBusy : begin
                 TimeStr:='';
                 DrawView;
               end;
      cmUpDate : Update;
      else exit;
    end;
    ClearEvent(Event);
  end;
end;

procedure TMyClock.Draw;
var
  B: TDrawBuffer;
  C: Byte;
begin
  C := GetColor(2);
  MoveChar(B, ' ', C, Size.X);
  if TimeStr<>'' then MoveStr(B[1], TimeStr, C)
  else MoveStr(B, '  Pracuji ', red*16+yellow);
  WriteLine(0, 0, Size.X, 1, B);
end;

constructor TMyEditWindow.Init(var Bounds: TRect;
      FileName: FNameStr; ANumber: Integer);
begin
  TEditWindow.Init(Bounds,FileName,ANumber);
  if ANumber in [0..9] then WinNums:=WinNums+[ANumber];
  Gramatika:=new(PBigGrammar,Init);
  HelpCtx:=hcEditWindow;
end;

destructor TMyEditWindow.Done;
begin
  if Gramatika<>nil then dispose(Gramatika,Done);
  if Number in [1..9] then WinNums:=WinNums-[Number];
  TEditWindow.Done;
end;

procedure TMyEditWindow.ReadGrammar;
begin
  if Gramatika=nil then begin
    Editor^.Ready:=false;
    exit;
  end else Gramatika^.Reset;
  Editor^.Ready:=Gramatika^.ReadGrammar(Editor);
end;

procedure TMyEditWindow.HandleEvent(var Event: TEvent);

 procedure UkazStav;
 var p:PDialog;
 begin
   Gramatika^.TestStates;
   p:=PDialog(Application^.ValidView(new(PStateDialog,Init(Gramatika))));
   if p<>nil then begin
     DeskTop^.ExecView(p);
     dispose(p,Done);
   end;
 end;

begin
  TEditWindow.HandleEvent(Event);
  case Event.What of
    evCommand: begin
      if Event.Command>255 then exit;
      if Event.Command<>cmEditor then begin
        if Event.Command in [cmUkazStav, cmTNadbytecne, cmTNedostupne,
 	     cmTRedukovana, cmTBezEpsilon, cmTCykly, cmTVlastni,
	     cmTJednoduche, cmTBezRekurze, cmTChomskeho, cmTGreibachova,
	     cmTZjednoduseni, cmDoWrite]
	then begin
          Message(Application,evBroadcast,cmBusy,nil);
          if not Editor^.Ready then begin
            ReadGrammar;
            if not MemOk or not Editor^.Ready then exit;
          end;
        end else if Event.Command=cmReadGrammar then 
          Message(Application,evBroadcast,cmBusy,nil)
        else exit;
        case Event.Command of
          cmUkazStav      : UkazStav;
          cmTNadbytecne   : Gramatika^.ZrusNadbytecne;
          cmTNedostupne   : Gramatika^.ZrusNedostupne;
          cmTRedukovana   : Gramatika^.ZrusNadbytecnaPravidla;
          cmTBezEpsilon   : Gramatika^.ZrusEpsilonovaPravidla;
          cmTCykly        : Gramatika^.ZrusPravidlaSCykly;
          cmTVlastni      : Gramatika^.VytvorVlastni;
          cmTJednoduche   : Gramatika^.ZrusJednoduchaPravidla;
          cmTBezRekurze   : begin
                              Gramatika^.VytvorVlastni;
                              Gramatika^.VytvorBezRekurze;
                            end;
          cmTChomskeho    : begin
                              Gramatika^.VytvorVlastni;
                              Gramatika^.VytvorChomskeho;
                            end;
          cmTGreibachova  : begin
                              Gramatika^.VytvorVlastni;
                              Gramatika^.VytvorGreibachova;
                            end;
          cmTZjednoduseni : Gramatika^.ZjednodusSymboly;
          cmReadGrammar   : ReadGrammar;
          cmDoWrite       : Message(Application,evCommand,cmWriteGrammar,Gramatika);
          else exit;
        end;
        if not(Event.Command in [cmDoWrite, cmReadGrammar, cmUkazStav])
        then begin
          Message(Application,evCommand,cmWriteGrammar,Gramatika);
          Editor^.Ready:=false;
        end;
        MemOk:=true;
      end;
    end;
    else exit;
  end;
  ClearEvent(Event);
end;

procedure ErrorBox(s:string;hlp:word);
var par:pointer;
    R:TRect;
    Dialog:PDialog;
    Control:PView;
begin
  R.Assign(0, 0, 40, 9);
  R.Move((Desktop^.Size.X - R.B.X) div 2, (Desktop^.Size.Y - R.B.Y) div 2);
  Dialog := New(PDialog, Init(R, 'Chyba'));
  with Dialog^ do
  begin
    HelpCtx:=hlp;
    R.Assign(3, 2, Size.X - 2, Size.Y - 3);
    Control := New(PStaticText, Init(R, S));
    Insert(Control);
    R.Assign(14, 6, 24, 8);
    Control := New(PButton, Init(R, 'O~K~', cmYes,
       bfNormal));
    Insert(Control);
    Control^.MoveTo(15, 6);
    SelectNext(False);
  end;
  DeskTop^.ExecView(Dialog);
  Dispose(Dialog, Done);
end;

end.
